package fr.lri.keller.td8correction;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class TD8Activity extends AppCompatActivity {

    public static final String EXTRA_SCORE = "EXTRA_SCORE";
    public static final String EXTRA_LEVEL = "EXTRA_LEVEL";
    public static final String UPDATE_SCORE_LEVEL = "UPDATE_SCORE_LEVEL";
    public static final String PREFERENCES = "PREFERENCES_TD8";

    private int score;
    private int level;

    private TextView textViewScore;
    private TextView textViewLevel;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_td8);
        textViewScore = (TextView) findViewById(R.id.textViewScore);
        textViewLevel = (TextView) findViewById(R.id.textViewLevel);

        // On récupère les données sauvergardées et on les affiche...
        SharedPreferences sharedPref = getSharedPreferences(PREFERENCES, MODE_PRIVATE);
        score = sharedPref.getInt(EXTRA_SCORE, 0);
        level = sharedPref.getInt(EXTRA_LEVEL, 1);
        textViewScore.setText("" + score);
        textViewLevel.setText("" + level);

        // ... sans oublier de les envoyer au widget
        sendToWidget();
    }

    // Méthode lorsqu'on clique sur le bouton
    public void clickTheButton(View view) {
        score++;
        textViewScore.setText(""+score);
        if (score % 5 == 0) {
            level++;
            textViewLevel.setText(""+level);
        }

        // Envoi des nouvelles données au widget
        sendToWidget();

        // Sauvegarde des nouvelles données dans les préférences partagées de l'application
        SharedPreferences sharedPreferences = getSharedPreferences(PREFERENCES, MODE_PRIVATE);
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putInt(EXTRA_SCORE, score);
        editor.putInt(EXTRA_LEVEL, level);
        editor.commit();
    }

    // Envoi des données au widget
    private void sendToWidget() {
        Intent intent = new Intent(this, TD8AppWidget.class);
        intent.putExtra(EXTRA_SCORE, score);
        intent.putExtra(EXTRA_LEVEL, level);
        intent.setAction(UPDATE_SCORE_LEVEL);
        sendBroadcast(intent);
    }
}
